
// Drehzahlmesser_mit_28BYJ48_12v12-02-2019
// ...... Bibliotheken ........

#include <Stepper.h> // Include the header file

// ---- Variablen für den Schrittmotor

int RPM_stepp = 0; // Umrechnung Drehhzahl in Schrittte für den Schrittmotor 
const int scala_max = 8000; // maximal angezeigte Drehzahl laut Scala,  Die Skala geht bis 8000 U/
const int max_stepps = 1252; // Anzahl der max_stepps von 0 bis Maximalanzeige z.B. eine volle Umdrehung des 28BYJ48 sind 2048  = 5,68 Schritte pro Grad die Scala geht über 220 Grad " 5,688 Grad pro Schritt) * 220 Grad = 1252 
unsigned long micro_Stepper_alt = 0; // merken wenn die Subroutine den Schrittmotor angesteuert hat, zweck auch wenn sich die Drehzahl nicht ändert soll der Schrittmotor nachgeführt werden sollt er die richtige Position noch nicht erreicht haben
unsigned long jetzt = 0; // aktueller Zeitpunkt dient dazu die zeit zwischen der letzten Ansteuerung Schrittmotor und dem Jetzt zu bestimmen 
unsigned long delta_Ansteuerung = 0;   // die Differenz zwischen der letzten Ansteuerung des Schrittmotor und jetzt

int Pos_Stepper = 0; // wo steht der Schrittmotor gerade diese Variabel wird zum zählen verwendet.
int delta_stepps = 0; // wie weit ist er von der Sollposition entfernt ?
unsigned int schrittweite_stepps = 1; // 1 hat sich als der beste Kompromiss erwiesen !!! der Schrittmotor wird in Einzelschritten nachgeführt !!

#define STEPS 32 // change this to the number of steps on your motor
Stepper stepper(STEPS, 8, 10, 9, 11); // create an instance of the stepper class using the steps and pins
//                 IN  1   3  2   4   input Pin am Driver Board dreht bei Erhöhung der Drehzahl nach links
//                 IN  4   2  3   1   input Pin am Driver Board dreht bei Erhöhung der Drehzahl nach rechts 

// --- Variabel Deffinition ---------------
volatile unsigned long micro = 0;      // der aktuelle Wert readmicros
volatile unsigned long micro_alt = 0;  // der Wert der vorangegangenen readmicros
volatile unsigned long diff = 0;   // die Differenz = Dauer einer Umdrehung
volatile unsigned long diff1 = 0;
volatile unsigned long diff2 = 0;   // für die Mittelwert Glättung verschieben der Werte 
volatile unsigned long diff3 = 0;   // für die Mittelwert Glättung verschieben der Werte 
volatile unsigned long diff4 = 0;   // für die Mittelwert Glättung verschieben der Werte 
volatile unsigned long Drehzahl = 0; // die errechnete Drehzahl 
volatile long Drehzahl_diff= 0 ; // der alte Wert die errechnete Drehzahl
volatile unsigned long Drehzahl_angezeigt = 0; // die errechnete Drehzahl 
volatile int delta; // Zum einstellen der Sprungwerte zwischen den angezeigten Drehzahlen
volatile boolean aktiv = 0; // soll die Drehzahl ausgegeben werden ?
long timeout; // die Zeitspanne zwischen zwei interrupts

int Zeiger = 0;  // ist der Zeiger in der Position 0 ?
boolean genullt = 0;  // ist der Zeiger zurückgeführt ? 0 = noch nicht 


void setup() {
Serial.begin(57600);

// ---- Variablen für den Schrittmotor
stepper.setSpeed(1200);


pinMode(2, INPUT); // Eingangspin auf Eingang stellen - Signaleingang Drehzahmessung
digitalWrite(2, HIGH); // und Pullup-Widerstand einschalten heist gemessen wird wenn der Eingang auf 0 gezogen wird.
attachInterrupt(0, readmicros, FALLING);  // Interrupt 0 auf Routine readmicros setzen

pinMode(LED_BUILTIN, OUTPUT); // Warnung Bei drehzahlen über den maximalen Scalenwert

// Schrittmotor initialisieren
pinMode(3, INPUT); // Eingangspin auf Eingang stellen erkennen der Nadelposition = Anfang = Position 0
digitalWrite(3, HIGH); // und Pullup-Widerstand einschalten
Zeiger = digitalRead(3); // Zustand einlesen um einen definierten Ausgangszustand herzustellen 
if ( Zeiger == HIGH ) {genullt = 1; }; // wenn der Zeiger schon in der null Position ist, braucht man nicht's mehr tun.
if ( genullt == 0 ) { nullen(); }  // ist der Zeiger schon in der null Position ? wenn ned ab in die Subroutiene  


}

//..............................................................................................
void loop(){

Drehzahl = 60000000L / diff;           // Drehzahl ausrechnen und (60000000 durch die Anzahl der Magneten teilen, ist in dem Fall = 1 
if (Drehzahl > scala_max) {Drehzahl = scala_max; digitalWrite(LED_BUILTIN, HIGH);} else {digitalWrite(LED_BUILTIN, LOW);} // ist die errechnete Drehzahl höher als scala_max U/Min dann den Wert auf scala_max setzen und die LED einschalten    


Drehzahl_diff = Drehzahl_angezeigt - Drehzahl;
Drehzahl_diff = abs(Drehzahl_diff); // die Bildung des abs Wert getrennt von der Berechnung, so gefordert in der Arduino IDE 

// nicht jede Wert soll ein Aktion auslösen! ----------------------------------------
if (Drehzahl <= 1500) { delta = 10;} 
if (Drehzahl > 1500 && Drehzahl <= 2500) {delta = 20;}
if (Drehzahl > 2500 ) {delta = 40;} 


// nur wenn Delta alt/neue Drehzahl einen bestimmten Wert überschreitet soll er angezeigt werden. Und der Schrittmotor wird angesteuert
if (aktiv == 1 && Drehzahl_diff >= delta) { Drehzahl_angezeigt = Drehzahl; Schrittmotor(); }


jetzt = micros(); // Microsekundenzähler auslesen um zu wissen ob ich die Anzeige aktualisiern werden soll
delta_Ansteuerung = jetzt - micro_Stepper_alt; // Die Zeit zwischen der letzten Ansteuerung des Schrittmotor und jetzt beruhgen/dämpfen der Anzeige
if (aktiv == 1 && delta_Ansteuerung > 4000L && delta_stepps > 0 ) Schrittmotor(); // Nachfahren der Anzeige


// Stillstand erkennen
timeout = micros() - micro_alt;
if (timeout > 2000000L)  {aktiv = 0; nullen();}  // Inaktivität unter 10 U/Min = 2 Sec   //  Zeiger Zurückführen
// if (aktiv == 0) nullen();    // Zeiger Zurückführen

  
}

//-------------------Den externen Interrupt auswerten-----------------------------------------------------------------------
void readmicros() {  // detachInterrupt(0);        // Interrupt 0 ausschalten 

if ( aktiv == 0 || micro_alt == 0) micro_alt = micros();  // wenn der Drehzahlmesser aus der inaktiven Phase angesteuert wird, wird micro_alt aktuallisiert. Beim nächsten Impuls wir eine sinnvolle Zeit gemessen
aktiv = 1;
micro = micros(); // Microsekundenzähler auslesen
diff = micro - micro_alt; // Differenz zum letzten Durchlauf berechnen

if (diff > 4000L) { // Drehzahen bzw. Impulsfolgen kürzer als bei 15000U/Min werden als Fehler erachtet und ignoriert   
                   micro_alt = micro;  // Letzten Wert merken
if (Drehzahl < 2500) { // genauere Mittelwertbildung 
  
                            diff4 = diff3;
                            diff3 = diff2;
                            diff2 = diff1;
                            diff1 = diff;
                            if (diff4 > 0 ) diff = (diff1 + diff2 + diff3 + diff4)/4;  // bei den ersten Impulsen werden erst die Werte diff2 - 4 befüllt deshalb die Berechnung mit diff1                                               
                        }                                                                                    
   
                   else {  //  wenn die Drehzahl höher wird, wird die Berechnung beschleunigt
                              diff2 = diff1;
                              diff1 = diff;
                              diff = (diff1 + diff2 )/2;  // Mittelwert bilden   
                        }
                   }
// attachInterrupt(0, readmicros, FALLING);   // Interrupt 0 auf Routine readmicros setzen
 }
//-----------------------------------------------------------------------------------------


//-----------------------Ansteuerung Schrittmotor-------------------------------------------
void Schrittmotor() { 
                     RPM_stepp = map(Drehzahl, 0, scala_max, 0, max_stepps);
                      
                      //  clockwise - ansteuern des Schrittmotor
                      if (RPM_stepp > Pos_Stepper) { 
                                                    if ((Pos_Stepper + schrittweite_stepps) > max_stepps) { schrittweite_stepps = 0; }                                                     
                                                    stepper.step(schrittweite_stepps);
                                                    Pos_Stepper = Pos_Stepper + schrittweite_stepps ;
                                                    }

                     
                      // anticlockwise- ansteuern des Schrittmotor
                      if (RPM_stepp < Pos_Stepper) {
                                                    if (Pos_Stepper < schrittweite_stepps) { schrittweite_stepps = 0; }
                                                    stepper.step(-schrittweite_stepps);
                                                    Pos_Stepper = Pos_Stepper - schrittweite_stepps;
                                                   }

                      micro_Stepper_alt = micros();  // Zeitpunkt merken an dem der Schrittmotor stehen bleibt als Basis um die nächste initialisierung zu planen

                                         // ---------- ist die Anzeige aktuell ? -----------------------------
                     delta_stepps = RPM_stepp - Pos_Stepper;    // wo stehe ich und wo will ich hin ?
                     delta_stepps = abs(delta_stepps);          // die Bildung des abs Wert getrennt von der Berechnung, so gefordert in der Arduino IDE 
                    } 

//------------------------------------------------------------------------------------------
void nullen() { // Schrittmotor auf die Startposition bewegen. Scalenwert 0
detachInterrupt(0); // Interrupt 0 ausschalten damit in Ruhe initialisiert werden kann

Serial.println("NULLEN");

for (int c = 0; c < max_stepps; c++)  { Zeiger = digitalRead(3); 
                             if ( Zeiger == LOW ) {stepper.step (-1);}
                             }
                                     
genullt = 1; // Erfolgreich initialisiert
Pos_Stepper = 0; // Der Zeiger seht auf Position 0
diff4 = 0; diff3 = 0; diff2 = 0; diff1 = 0; // initialisieren ;-) die Drehzahl erst nach dem 4ten Impuls berechnet 
Drehzahl = 0; // damit bei Aktiv = 1 nicht der alte Wert angezeigt wird befor er bei der Berechnung mit dem neuen Wert überschrieben wird
Drehzahl_angezeigt = 0; // damit bei Aktiv = 1 nicht der alte Wert angezeigt wird befor er bei der Berechnung mit dem neuen Wert überschrieben wird
attachInterrupt(0, readmicros, FALLING);   // Interrupt 0 wieder einschalten jetzt kann es losgehen
  
  }
  
  //--------------------------------------------------------------------------------------------------------
